function [nwtn, rlrs, pcgi]  = lbfgs_wrapper(PCG, Hessian, g, opts)

if (~isfield(PCG,'g_old'))
    % Initialize variables for preconditioner.
    PCG.S = zeros(opts.n,opts.rankupdates);
    PCG.Y = zeros(opts.n,opts.rankupdates);
    PCG.YS = zeros(opts.rankupdates,1);
    PCG.lbfgs_start = 1;
    PCG.lbfgs_end = 0;
    PCG.Hdiag = 1;
    
    % Calculate Newton direction.
    [nwtn, ~, rlrs, pcgi] = pcg(Hessian,-g,opts.tolpcg,opts.mxitrpcg);
else
    % Update data for preconditioner.
    [PCG.S,PCG.Y,PCG.YS,PCG.lbfgs_start,PCG.lbfgs_end,PCG.Hdiag] = lbfgsAdd(g-PCG.g_old,PCG.a*PCG.nwtn_old,...
        PCG.S,PCG.Y,PCG.YS,PCG.lbfgs_start,PCG.lbfgs_end,PCG.Hdiag,1);
    
    % Define preconditioner.
    Preconditioner = @(q) lbfgsProdC(q,PCG.S,PCG.Y,PCG.YS,int32(PCG.lbfgs_start),...
        int32(PCG.lbfgs_end),PCG.Hdiag);
    
    % Calculate Newton direction.
    [nwtn, ~, rlrs, pcgi] = pcg(Hessian,-g,opts.tolpcg,...
        opts.mxitrpcg,Preconditioner);   
end
PCG.nwtn_old  = nwtn;
PCG.g_old = g;
assignin('caller','PCG',PCG);
end